package com.example.libmedia.demo.video;

import android.webkit.WebView;
import android.webkit.WebViewClient;
import fr.maxcom.http.HttpServer;

import javax.crypto.Cipher;

/**
 * A variant that plays a clear video.
 */
public class WebActivity1 extends AWebActivity {

	/**
	 * No need to return a cipher for a clear video.
	 */
	@Override
	public Cipher getCipher() {
		return null;
	}

	public String getPath() {
		// to have a self-contained application, get the media from the assets directory.
		return "asset://clear.mp4";
	}

	/**
	 * A demo with the Host-driven design:
	 * The host application is the master and controls the video source.
	 * 
	 * See the WebActivity2 for the JavaScript-driven design.
	 */
	@Override
	public void demo(WebView webview, HttpServer server) {
		String path = getPath();
		path = server.getURL(path);
		final String mediaPath = path;  // just because 'final' is mandatory
		webview.setWebViewClient(new WebViewClient() {
			@Override
			public void onPageFinished(WebView view, String url) {
				view.loadUrl("javascript:setURL('" + mediaPath + "'); void(0);");
			}
		});
		String page = "<html><body>"
				+ "<script>"
				+ "function setURL(url) { document.getElementById('v_id').src = url; }"
				+ "</script>"
				+ "<video id=\"v_id\" controls></video>"
				+ "</body></html>";
		webview.loadData(page, "text/html", null);
	}
}
