package com.example.libmedia.demo.video;

import android.webkit.WebView;
import android.webkit.WebViewClient;
import fr.maxcom.http.HttpServer;

import java.security.GeneralSecurityException;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

/**
 * A variant that plays an encrypted video.
 */
public class WebActivity2 extends AWebActivity {

	@Override
	public Cipher getCipher() throws GeneralSecurityException {
		final Cipher c = Cipher.getInstance("ARC4");	// NoSuchAlgorithmException, NoSuchPaddingException
		c.init(Cipher.DECRYPT_MODE, new SecretKeySpec("BrianIsInTheKitchen".getBytes(), "ARC4"));	// InvalidKeyException
		return c;
	}

	public String getPath() {
		// to have a self-contained application, get the media from the assets directory.
		return "asset://encrypted.mp4";
	}

	/**
	 * A demo with the JavaScript-driven design:
	 * The HTML page has some embedded interaction widgets to allow the user to select a media.
	 * 
	 * See the WebActivity1 for the Host-driven design.
	 */
	@Override
	public void demo(WebView webview, HttpServer server) {
		// this setting is only to simulate a user interaction for the demo
		webview.setWebViewClient(new WebViewClient() {
			@Override
			public void onPageFinished(WebView view, String url) {
				view.loadUrl("javascript:setPath(); void(0);");
			}
		});

		webview.addJavascriptInterface(server.getJsInterfaceObject(), "serverObject");
		String page = "<html><body>"
				+ "<script>"
				+ "function setURL(url) { document.getElementById('v_id').src = url; }"
				+ "function setPath() { setURL(serverObject.getURL('" + getPath() + "')); }"
				+ "</script>"
				+ "<video id=\"v_id\" controls></video>"
				+ "</body></html>";
		webview.loadData(page, "text/html", null);
	}
}
